// Tunnel Version 1.01
// by David Coz  Coz.hubert@infonie.fr
// Created 25/11/2001; 18:15:05

#define USE_TI89              // Produce .89z File


#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

/*Structure for saving highscores...*/


typedef struct
  {
    char name[10];
    unsigned long score;
  } HSC_ITEM;

/*Find the Hardware Version for adjusting speed (found in TIGCC help)*/
unsigned long GetHardwareVersion ()
{
  unsigned long hwpb, *rombase;
  rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
  hwpb = rombase[65];
  return (hwpb - (unsigned long)rombase  < 0x10000 &&
    *(unsigned short *)hwpb > 22 ? *(unsigned long *)(hwpb + 22) : 1);
}

 /*Function to input your name (thanks to Zeljko Juric with Cave Blaster...)*/
 
 void input_str(char *str)
{
ClrScr();
  int i=0,key=0;
    FontSetSys(F_8x10);
  DrawStr(10,10,"CONGRATULATIONS!",A_NORMAL);
  FontSetSys(F_6x8);
  DrawStr(10,30,"You are First!",A_NORMAL);
  DrawStr(10,50,"Enter Your Name:",A_NORMAL);
  
  while(key!=13)
    {
      str[i]='_'; str[i+1]=' '; str[i+2]=0;
      DrawStr(30,60,str,A_REPLACE);
      key=ngetchx();
      if(key>=' '&&key<='~'&&i<8) str[i++]=key;
      if(key==257&&i)
      {
      	//str[i]=' ';
      	i--;
      }
}
str[i]=0;
}

/*Scrolling Down Routine,thanks to Thomas Nussbaumer...*/

void ScrollDown(unsigned short* buffer,unsigned short lines) {
    register short* dest = buffer;
    register short* src;
    register short  tmplines  = lines;

    dest += (tmplines<<4) - (tmplines);
    src   = dest - 15;

    tmplines -= 2;

    asm volatile (
       "0:
        move.l -(%0),-(%1);move.l -(%0),-(%1);move.l -(%0),-(%1)
        move.l -(%0),-(%1);move.l -(%0),-(%1);move.l -(%0),-(%1)
        move.l -(%0),-(%1);move.w -(%0),-(%1)
        dbra %2,0b
        clr.l -(%1);clr.l -(%1);clr.l -(%1);clr.l -(%1)
        clr.l -(%1);clr.l -(%1);clr.l -(%1);clr.w -(%1)"
        : "=a" (src), "=a" (dest), "=d" (tmplines)
        : "0"  (src), "1"  (dest), "2"  (tmplines));
}



// Main Function
void _main(void)
{
/*Initial Highscores...*/
int level_choice=0,key=0,i;
unsigned long hw=GetHardwareVersion ();

static HSC_ITEM bestscore[5]={{"David",3000},{"David",2500},
    {"David",2000},{"David",1500},{"David",1000}};

 HSC_ITEM level[5]={{"Very Easy",28},{"Easy     ",23},{"Medium    ",18},
{"Hard     ",15},{"Very Hard",11}};
 

while(1)
{
ClrScr();
/* Draw the 'Tunnel' Title*/

BitmapPut(12,6,(BITMAP *)&(unsigned char[]){0,40,0,136,
0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xC0,0x00,0x01,0xC0,0x00,0x00,0x07,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x00,0x07,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x00,0x07,0xF0,0x00,0x3F,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x07,0xE0,0x00,0x07,0xE7,0x80,0x00,0x07,0xE0,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x30,0x0F,0xE0,0x30,0x0F,0xEF,0xFF,0xFF,0x07,0xE0,0x00,0xFF,0xF0,0x00,0x00,0x00,0x00,0x78,0x0F,0xC0,0x78,0x0F,0xCF,0xFF,0xFF,0x87,0xC0,0x00,0xFF,0xB8,0x00,0x78,0x03,0x00,0x78,0x6F,0xC0,0x78,0x6F,0xCF,0xFF,0xF1,0x87,0xC0,0x00,0x3F,0x7C,0x00,0xFE,0x03,0x00,0xF8,0x0F,0x80,0xF8,0x0F,0x87,0xFF,0x80,0x07,0xC0,0x00,0x00,0x7C,0x00,0xFE,0x03,0x00,0xF8,0x0F,0x80,0xF8,0x0F,0x83,0x80,0x00,0x07,0xC0,0x00,0x00,0x78,0x00,0xFE,0x03,0x00,0xF8,0x07,0x80,0xF8,0x07,0x83,0x00,0x00,0x07,0x80,0x00,0x00,0x38,0x00,0x7C,0x03,0x00,0xF8,0x07,0x80,0xF8,0x07,0x83,0x00,0x00,0x07,0x80,0x00,0x00,0x38,0x00,0x78,0x03,0x61,0xF8,0x07,0x81,0xF8,0x07,0x87,0x00,0x00,0x07,0x80,0x00,0x00,0x38,0x00,0xF8,0x03,0x01,0xFC,0x07,0x81,0xFC,0x07,0x86,0x00,0x00,0x07,0x80,0x00,0x00,0x38,0x00,0xF8,0x03,0x01,0xFC,0x07,0x81,0xFC,0x07,0x86,0x00,0x00,0x07,0x00,0x00,0x00,0x38,0x00,0xF0,0x03,0x03,0xEC,0x0F,0x03,0xEC,0x0F,0x06,0x00,0x00,0x07,0x00,0x00,0x00,0x38,0x00,0xF0,0x03,0x03,0xEC,0x0F,0x03,0xEC,0x0F,0x06,0x00,0x00,0x37,0x00,0x00,0x00,0x30,0x00,0xE0,0x03,0x03,0xEC,0x0F,0x03,0xEC,0x0F,0x06,0xFE,0x00,0x07,0x00,0x00,0x00,0x30,0x01,0xE0,0x06,0x01,0xE6,0x1E,0x01,0xE6,0x1E,0x07,0xFF,0xF0,0x07,0x00,0x00,0x00,0x30,0x00,0xE0,0x06,0x01,0xE6,0x1E,0x01,0xE6,0x1E,0x07,0xF0,0x00,0x07,0x00,0x00,0x00,0x30,0x01,0xC0,0x06,0x01,0xE6,0x3C,0x01,0xE6,0x3C,0x06,0x00,0x00,0x06,0x00,0x00,0x00,0x30,0x01,0xC0,0x06,0x03,0xC7,0x3C,0x03,0xC7,0x3C,0x06,0x00,0x00,0x06,0x00,0x00,0x00,0x30,0x01,0xC0,0x0E,0x03,0xC7,0x3C,0x03,0xC7,0x3C,0x06,0x00,0x00,0x06,0x00,0xC0,0x00,0x30,0x01,0xC0,0x0C,0x03,0xC3,0x38,0x03,0xC3,0x38,0x06,0x00,0x00,0x06,0x00,0x00,0x00,0x30,0x01,0xC0,0x0C,0x03,0x83,0x38,0x03,0x83,0x38,0x03,0x00,0x00,0x06,0x00,0x00,0x00,0x30,0x01,0xC0,0x1C,0x07,0x83,0x78,0x07,0x83,0x78,0x03,0x00,0x00,0x0E,0x00,0x00,0x00,0x30,0x01,0xC0,0x18,0x07,0x81,0xF0,0x07,0x81,0xF0,0x03,0x00,0x00,0x0E,0x00,0x00,0x00,0x30,0x00,0xE0,0x38,0x0F,0x81,0xF0,0x0F,0x81,0xF0,0x01,0x80,0x00,0x0C,0x00,0x00,0x00,0x30,0x00,0xF0,0xF0,0x0F,0x81,0xF0,0x0F,0x81,0xF0,0x01,0xC0,0x00,0x0C,0x00,0x70,0x00,0x30,0x00,0x7F,0xE0,0x0F,0x81,0xF0,0x0F,0x81,0xF0,0x00,0xE0,0x00,0x0C,0x0F,0xF8,0x00,0x30,0x00,0x3F,0xC0,0x07,0x80,0xF0,0x07,0x80,0xF0,0x00,0xF8,0x00,0x0F,0xFF,0xF8,0x00,0x30,0x00,0x00,0x00,0x07,0x00,0xF0,0x07,0x00,0xF0,0x00,0x7F,0xC0,0x0F,0xFF,0xF8,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x00,0x60,0x00,0x0F,0xFC,0x0F,0xFF,0xF8,0x00,0x30,0x00,0x00,0x00,0x03,0x00,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x0F,0xFE,0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
},&(SCR_RECT){{0,0,239,127}},A_REPLACE);

DrawStr(13,62,"Level :",A_NORMAL);
FontSetSys(F_8x10);
DrawStr(42,43,"-Classic-",A_NORMAL);

FontSetSys(F_4x6);
DrawStr(38,88,"2002 v 1.01 by David Coz",A_NORMAL);
DrawStr(43,94,"Coz.hubert@infonie.fr",A_NORMAL);

FontSetSys(F_6x8);

 while (key!=13)
{

DrawStr(60,62,level[level_choice].name,A_REPLACE);
DrawStr(13,73,"Best  :",A_NORMAL);
DrawStr(60,73,"               ",A_REPLACE);
DrawStr(110,73,bestscore[level_choice].name,A_NORMAL);
printf_xy(60,73,"%ld by",bestscore[level_choice].score);

key=ngetchx();
if (key==344)
{
level_choice++;
	if (level_choice==5)
level_choice=0;
}
if (key==338)
{
level_choice--;
	if (level_choice==-1)
level_choice=4;
}
if (key==264)
return;

}
restart:
ClrScr();
	OSSetSR(0x0400);
static char plane[8]=	{0x00,0x18,0x3C,0xA5,0xBD,0xFF,0xFF,0x7E};
unsigned int quit=1,x=70,j,speed,score=0,large=70;
//large = size of the tunnel


/*Adjuste Speed,depending on Level and Calc Hardware...*/

speed=level[level_choice].score;
speed*=(hw==2 ? 6 :5);

	randomize();
           
  int b,a=20+random(60);     
// a  is the left x value of the tunnel 
	while (quit==1)
	{

 b=-4+random(9);

	 
	if (a+b<0)
	b=0;
	if (a+b>105)
	b=0;

	DrawLine(0,0,a+b,0,A_NORMAL);
	DrawLine(a+large+b,0,160,0,A_NORMAL);
ScrollDown(LCD_MEM,100);
	Sprite8(x,90,8,plane,LCD_MEM,SPRT_XOR);
	a=b+a;
	
	/*Waiting Loop...*/
for (i=0;i<2*speed;i++)

	{
	for (j=0;j<4000;j++)
	{
	}	
	}
score++;

if (score%300==1)
large--;

// Key Detection... 
	if (_rowread(0x3F)&0x1)
	quit=0;
	if(_rowread(~((short)(1<<1))) & (1<<6))
	off();

		if (_rowread(0x7E)&0x08&&x!=1)
		x++;
		if (_rowread(0x7E)&0x02&&x<150)
		x--;
		
//You loose !!!
	if (GetPix(x,90)||GetPix(x+7,90)) 
break;


	}

	FontSetSys(F_8x10);
	DrawStr(30,30,"GAME OVER",A_REPLACE);
	FontSetSys(F_6x8);

	DrawStr(20,50,"                       ",A_REPLACE);
printf_xy(20,50,"Your Score is :%d",score);
	key=0;
	while (key!=13&&key!=264)
	{
	key=ngetchx();
	} 

if (score>bestscore[level_choice].score)
{
input_str(bestscore[level_choice].name);
bestscore[level_choice].score=score;
}	
if (key==13)
goto restart;
	
 }
 
            
}


// by David Coz  Coz.hubert@infonie.fr